#!/usr/bin/perl

# this uses a system call to get the pdb and then break it
# up into its headers and models

# form getnmrModels.pl < [list of pdbs] > [list of all pdbs outputted]

while ($line=<STDIN>)  {
    chop($line); @nms=split(' ',$line);
    foreach $base (@nms)  {
	$base =~ s/\.pdb$//g;

	@ssbond=(); 
	if( !(system "gzcat /hosts/hyper/big/PDB/*/$base.pdb.gz > $base.pdb")) {
	    open PDB, "$base.pdb" or printf STDERR "Strange, couldn't open $base.pdb\n";
	    open HDR, ">$base-header" or die "Couldn't open $base-header: $!\n";
	    $topdb=0;
	    while($pline=<PDB>)  {
		if($pline =~ "^MODEL") {
		    printf HDR "$pline"; chop($pline); @in=split(' ',$pline);
		    open MDL, ">${base}-m${in[1]}.pdb" or die "Couldn't open ${base}-m${in[1]}.pdb: $!\n";
		    foreach $ss (@ssbond)  { printf MDL "$ss"; }
		    print "${base}-m${in[1]}.pdb\n"; $topdb++;
		}
		elsif($pline =~ "^ENDMDL")  { close MDL; printf HDR "$pline"; }
		elsif($pline =~ "^SSBOND")  { push @ssbond, $pline; printf HDR "$pline"; }
		elsif($topdb)               { printf MDL "$pline"; }
		else                        { printf HDR "$pline"; }
	    }
	    close PDB; close HDR;
	    if($topdb == 0)  { system "mv $base-header $base.pdb"; print "$base.pdb\n"; }
	    else { system "rm $base.pdb"; }
	}
	else { system "rm $base.pdb"; }
    }
}
